
Core - Bug # 55180

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Task # 55179 (Closed): Optimize SQL Performance

Status: Resolved Priority: Should have
Author: Ingo Schmitt Category: Performance
Created: 2014-01-20 Assigned To: Ingo Schmitt
Updated: 2014-12-13 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: easy
Is Regression: No
Sprint Focus:
Subject: Increase Determination of siteroot page
Description

TYPO3 detects the rootpage by issuing a where clause on the pages table:

Count: 786  Time=0.04s (35s)  Lock=0.00s (0s)  Rows=0.0 (0), webuser[webuser]@localhost
  SELECT uid FROM pages WHERE deleted=N AND hidden=N AND is_siteroot=N LIMIT N

no index on  is_siteroot and hidden.

Related issues:
related to Core - Bug # 55534: Fix typo in typo3/sysext/core/ext_tables.sql Resolved 2014-01-31
related to Core - Bug # 59824: Better index for determineSiteRoot Resolved 2014-06-23

Associated revisions
Revision 7a71192e - 2014-01-31 18:12 - Ingo Schmitt

[BUGFIX] Add index to table pages

To detects the siteroot by querying the pages table with the
columns deleted, hidden, is_siteroot. This patch introduces
a combined index on those colums

Resolves: #55180
Releases: 6.2
Change-Id: Icae63670419cf9bc0029e2aa570cdf0108b9d62a
Reviewed-on: https://review.typo3.org/27154
Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring
Reviewed-by: Marcin Sągol
Reviewed-by: Benjamin Mack
Tested-by: Benjamin Mack

History
#1 - 2014-01-20 18:50 - Markus Klein

Hi Ingo.

2015-08-04 1/2

https://review.typo3.org/27154


Count: 786
Is that for one single FE/BE request??

#2 - 2014-01-30 15:05 - Ingo Schmitt
- Category set to Performance

Is for each FE Request

#3 - 2014-01-30 15:51 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27154

#4 - 2014-01-30 15:53 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27154

#5 - 2014-01-31 18:30 - Ingo Schmitt
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:7a71192e02ac21d35866307a7876d9f0c58423b9.

#6 - 2014-02-18 09:45 - Ingo Schmitt
- Estimated time changed from 0.50 to 2.00

#7 - 2014-12-13 22:01 - Christian Kuhn

Actually, this query is not fired this way at all!

the siteroot determination works by first finding the uid of the requested page, then getting its rootline, then iterating over it to see which of it has
is_siteroot set.

where did this query actually came from, and which code part of the core fires it? i could not find anything like that, so imho the created index is bogus.
if some extension (like TV) does stuff like that, it should add its index on its own.

... still investigating on this since i'm not 100% sure about those claims ... i woke up again on this topic because of pending patch 
https://review.typo3.org/#/c/31082/ which wants to change this index again (also for questionable reasons) ...
